import java.util.*;

import ru.ifmo.testlib.*;
import ru.ifmo.testlib.Outcome.Type;

public class Check implements Checker {

	@Override
	public Outcome test(InStream inf, InStream ouf, InStream ans) {
		int tests = inf.nextInt();
		for (int test = 0; test < tests; test++) {
			int n = inf.nextInt();
			int[] lis = new int[n];
			for (int i = 0; i < n; i++) {
				lis[i] = inf.nextInt();
			}
			long[] pAns = new long[n];
			HashSet<Long> hs = new HashSet<>();
			for (int i = 0; i < n; i++) {
				pAns[i] = ouf.nextLong();
				if (pAns[i] <= 0) {
					return new Outcome(Type.PE, "Number at position: "
							+ (i + 1) + " negative in testcase: " + test);
				}
				if (pAns[i] > (long) 1e15) {
					return new Outcome(Type.PE, "Number at position: "
							+ (i + 1) + "is large in testcase: " + test);
				}
				if (hs.contains(pAns[i])) {
					return new Outcome(Type.WA, pAns[i]
							+ " expected two and more");
				}
				hs.add(pAns[i]);
			}
			int[] pLis = LIS(pAns);
			if (!Arrays.equals(lis, pLis)) {
				return new Outcome(Type.WA, "Incorrect LIS in testcase: "
						+ (test + 1));
			}
		}
		return new Outcome(Type.OK, "Ok");
	}

	private int[] LIS(long[] a) {
		int n = a.length;
		long[] d = new long[n + 1];
		Arrays.fill(d, Long.MAX_VALUE);
		d[0] = 0;
		int[] ans = new int[n];
		for (int i = 0; i < n; i++) {
			int l = 0, r = n;
			while (l < r - 1) {
				int mid = (l + r) / 2;
				if (d[mid] < a[i])
					l = mid;
				else
					r = mid;
			}
			d[l + 1] = a[i];
			ans[i] = l + 1;
		}
		return ans;
	}
}