#include <iostream>
#include <string>
#include <vector>

using namespace std;

const int N = 14;
const int M = 100;
const long long MOD = 1e9 + 7;

long long POW3[N + 3];
int f[N][M];
int n, m;

void init(int pos, int acc, vector<long long>& dp, int prev = -1)
{
    if (pos == n + 1)
    {
        dp[acc]++;
        return;
    }
    int x, y;
    if (pos == 0)
    {
        x = 0;
        y = 1;
    } else {
        x = pos - 1;
        y = 0;
    }
    if (f[x][y] == -1)
    {
        for (int i = 0; i < 3; i++)
            if (i != prev)
                init(pos + 1, acc + POW3[pos] * i, dp, i);
    } else {
        if (f[x][y] != prev)
            init(pos + 1, acc + POW3[pos] * f[x][y], dp, f[x][y]);
    }
}

int get(int mask, int i)
{
    long long x = mask % POW3[i + 1];
    long long d = POW3[i];
    if (x < d)
        return 0;
    if (x < d + d)
        return 1;
    return 2;
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v)
{
    out << "[";
    for (size_t i = 0; i < v.size(); i++)
    {
        out << v[i];
        if (i != v.size() - 1)
            out << ", ";
    }
    return out << "]";
}

int main()
{
    cin >> n >> m;
    POW3[0] = 1;
    for (size_t i = 1; i < N + 3; i++)
        POW3[i] = POW3[i - 1] * 3;
    for (int i = 0; i < n; i++)
    {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            int c = -1;
            if (s[j] == 'B')
                c = 0;
            if (s[j] == 'G')
                c = 1;
            if (s[j] == 'W')
                c = 2;
            f[i][j] = c;
        }
    }
    
    if (n == 1 && m == 1)
    {
        cout << (f[0][0] == -1 ? 3 : 1) << "\n";
        return 0;
    }
    
    if (m == 1)
    {
        for (int i = 0; i < n; i++)
            f[0][i] = f[i][0];
        swap(n, m);        
    }
    
    vector<long long> dp(POW3[n + 1]);
    vector<long long> newDp(POW3[n + 1]);
    vector<int> ver1(POW3[n + 1]);
    vector<int> ver2(POW3[n + 1]);
    int vv1 = 1;
    int vv2 = 1;
    init(0, 0, dp);   
    for (size_t i = 0; i < dp.size(); i++)
        if (dp[i] != 0)
            ver1[i] = vv1;
    
    for (int y = 0; y < m - 1; y++)
    {
        for (int x = 0; x < n - 1; x++)
        {
            vv2++;
            for (int mask = 0; mask < POW3[n + 1]; mask++)
            {
                if (ver1[mask] != vv1)
                {
                    continue;
                }
                int prev = get(mask, x + 1);
                int newMask = mask - prev * POW3[x + 1];
                
                int variants[] = {0, 1, 2};
                int variantsSize = 3;
                if (f[x + 1][y + 1] != -1)
                {
                    variants[0] = f[x + 1][y + 1];
                    variantsSize = 1;
                }
                int prevDenied = get(mask, x);
                int nextDenied = get(mask, x + 2);
                for (int v = 0; v < variantsSize; v++)
                {
                    int newNewMask = newMask + variants[v] * POW3[x + 1];
                    int here = get(newNewMask, x + 1);
                    if (here != prevDenied && here != nextDenied)
                    {                        
                        long long& v = newDp[newNewMask];
                        if (ver2[newNewMask] != vv2)
                        {
                            v = 0;
                            ver2[newNewMask] = vv2;
                        }
                        v += dp[mask];
                        if (v >= MOD)
                            v -= MOD;
                    }
                }
            }
            swap(dp, newDp);
            swap(ver1, ver2);
            swap(vv1, vv2);
        }                
        
        if (y != m - 2)
        {
            vv2++;
            for (int mask = 0; mask < POW3[n + 1]; mask++)
            {
                if (ver1[mask] != vv1)
                    continue;
                int newMask = mask - POW3[n] * get(mask, n);
                newMask *= 3;

                int variants[] = {0, 1, 2};
                int variantsSize = 3;
                if (f[0][y + 2] != -1)
                {
                    variants[0] = f[0][y + 2];
                    variantsSize = 1;
                }
                int denied = get(mask, 0);
                for (int v = 0; v < variantsSize; v++)
                {
                    int newNewMask = newMask + variants[v];
                    int here = get(newNewMask, 0);
                    if (here != denied)
                    {
                        long long& v = newDp[newNewMask];
                        if (ver2[newNewMask] != vv2)
                        {
                            v = 0;
                            ver2[newNewMask] = vv2;
                        }
                        v += dp[mask];
                        if (v >= MOD)
                            v -= MOD;
                    }
                }
            }
            swap(dp, newDp);
            swap(ver1, ver2);
            swap(vv1, vv2);
        }
        
    }
    
    long long sum = 0;
    for (size_t i = 0; i < dp.size(); i++)
        if (ver1[i] == vv1)
            sum += dp[i];
    cout << (sum % MOD) << "\n";
}
