#include <iostream>
#include <string>
#include <vector>

using namespace std;

const int N = 14;
const int M = 100;
const long long MOD = 1e9 + 7;

long long POW3[N + 3];
int f[N][M];
int n, m;

char GET[14][4782969];

int get(int mask, int i)
{
    return GET[i][mask];
}

void initGET()
{
    vector<int> MOD(14, 0);

    for (int mask = 0; mask < 4782969; mask++)
    {
        for (int i = 0; i < 14; i++)
        {
            int x = MOD[i]++;
            if (MOD[i] >= POW3[i + 1])
                MOD[i] -= POW3[i + 1];
            int d = POW3[i];
            char& v = GET[i][mask];
            if (x < d)
                v = 0;
            else if (x < d + d)
                v = 1;
            else
                v = 2;
        }
    }
}

void init(int pos, int acc, vector<long long>& dp, int prev, int atZero)
{
    if (pos == n)
    {
        if (get(acc, 0) != atZero && get(acc, 1) != atZero)
            dp[acc]++;
        return;
    }
    int x = pos;
    int y = pos == 0;

    if (f[x][y] == -1)
    {
        for (int i = 0; i < 3; i++)
            if (i != prev || pos <= 1)
                init(pos + 1, acc + POW3[pos] * i, dp, i, atZero);
    } else {
        if (f[x][y] != prev || pos <= 1)
            init(pos + 1, acc + POW3[pos] * f[x][y], dp, f[x][y], atZero);
    }
}

    template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v)
{
    out << "[";
    for (size_t i = 0; i < v.size(); i++)
    {
        out << v[i];
        if (i != v.size() - 1)
            out << ", ";
    }
    return out << "]";
}

long long solve1()
{
    vector<vector<long long> > dp(3, vector<long long>(m));
    if (f[0][0] != -1)
    {
        dp[f[0][0]][0] = 1;
    } else {
        dp[0][0] = 1;
        dp[1][0] = 1;
        dp[2][0] = 1;
    }
    for (int i = 1; i < m; i++)
    {
        for (int from = 0; from < 3; from++)
        {
            for (int to = 0; to < 3; to++)
            {
                if (from == to)
                    continue;
                if (f[0][i-1] != -1 && f[0][i-1] != from)
                    continue;
                if (f[0][i] != -1 && f[0][i] != to)
                    continue;
                dp[to][i] += dp[from][i - 1];
            }
        }
    }
    return dp[0][m - 1] + dp[1][m - 1] + dp[2][m - 1];
}

int main()
{
    cin >> n >> m;
    POW3[0] = 1;
    for (size_t i = 1; i < N + 3; i++)
        POW3[i] = POW3[i - 1] * 3;
    initGET();
    for (int i = 0; i < n; i++)
    {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            int c = -1;
            if (s[j] == 'B')
                c = 0;
            if (s[j] == 'G')
                c = 1;
            if (s[j] == 'W')
                c = 2;
            f[i][j] = c;
        }
    }
    
    if (n == 1 && m == 1)
    {
        cout << (f[0][0] == -1 ? 3 : 1) << "\n";
        return 0;
    }
    
    if (m == 1)
    {
        for (int i = 0; i < n; i++)
            f[0][i] = f[i][0];
        swap(n, m);        
    }

    if (n == 1)
    {
        cout << solve1();
        return 0;
    }
    
    vector<long long> dp(POW3[n]);
    vector<long long> newDp(POW3[n]);
    if (f[0][0] == -1)
    {
        init(0, 0, dp, -1, 0);
        init(0, 0, dp, -1, 1);
        init(0, 0, dp, -1, 2);
    } else {
        init(0, 0, dp, -1, f[0][0]);
    }

    for (int y = 0; y < m - 1; y++)
    {
        for (int x = 0; x < n - 1; x++)
        {
            fill(newDp.begin(), newDp.end(), 0);
            for (int mask = 0; mask < POW3[n]; mask++)
            {
                if (dp[mask] == 0)
                {
                    continue;
                }
                int prev = get(mask, x + 1);
                int newMask = mask - prev * POW3[x + 1];
                
                int variants[] = {0, 1, 2};
                int variantsSize = 3;
                if (f[x + 1][y + 1] != -1)
                {
                    variants[0] = f[x + 1][y + 1];
                    variantsSize = 1;
                }
                int prevDenied = get(mask, x);
                int nextDenied = prev;
                for (int v = 0; v < variantsSize; v++)
                {
                    int newNewMask = newMask + variants[v] * POW3[x + 1];
                    int here = get(newNewMask, x + 1);
                    if (here != prevDenied && here != nextDenied)
                    {                        
                        long long& v = newDp[newNewMask];
                        v += dp[mask];
                        if (v >= MOD)
                            v -= MOD;
                    }
                }
            }
            swap(dp, newDp);
        }                
        
        if (y != m - 2)
        {
            fill(newDp.begin(), newDp.end(), 0);
            for (int mask = 0; mask < POW3[n]; mask++)
            {
                if (dp[mask] == 0)
                    continue;
                int denied = get(mask, 0);
                int newMask = mask - denied;

                int variants[] = {0, 1, 2};
                int variantsSize = 3;
                if (f[0][y + 2] != -1)
                {
                    variants[0] = f[0][y + 2];
                    variantsSize = 1;
                }
                
                for (int v = 0; v < variantsSize; v++)
                {
                    int var = variants[v];
                    if (var == denied)
                        continue;

                    int newNewMask = newMask + var;
                    long long& vv = newDp[newNewMask];
                    vv += dp[mask];
                    if (vv >= MOD)
                        vv -= MOD;
                }

            }
            swap(dp, newDp);
        }

    }
    
    long long sum = 0;
    for (size_t i = 0; i < dp.size(); i++)
        sum += dp[i];
    cout << (sum % MOD) << "\n";
}
