import java.io.*;
import java.util.*;

public class chess_vd_hight_precision {

	long mod = (long) (1e+9 + 7);
	final int[][] nValues = new int[][] { { 1, 0, 0 }, { 2, 2, 1 } };
	final int[][] getMask = new int[][] { { -1, 1, 1 }, { 0, -1, 1 },
			{ 0, 0, -1 } };

	public void solve() throws IOException {
		long tm = System.currentTimeMillis();
		int n = nextInt();
		int m = nextInt();
		int[][] field = new int[n][m];
		for (int i = 0; i < n; i++) {
			String s = next();
			for (int j = 0; j < s.length(); j++) {
				if (s.charAt(j) == '.') {
					field[i][j] = -1;
				} else if (s.charAt(j) == 'B') {
					field[i][j] = 0;
				} else if (s.charAt(j) == 'W') {
					field[i][j] = 1;
				} else {
					field[i][j] = 2;
				}
			}
		}
		int[] pow2 = new int[n + 1];
		pow2[0] = 1;
		for (int i = 1; i <= n; i++) {
			pow2[i] = pow2[i - 1] * 2;
		}
		int[][][] val = new int[3][n + 1][pow2[n]];
		for (int start = 0; start < 3; start++) {
			val[start][0][0] = start;
		}

		for (int start = 0; start < 3; start++) {
			for (int i = 1; i <= n; i++) {
				for (int mask = 0; mask < pow2[i]; mask++) {
					int next = ((mask & pow2[i - 1]) == 0) ? 0 : 1;
					int prev = val[start][i - 1][mask & (pow2[i - 1] - 1)];
					val[start][i][mask] = nValues[next][prev];
				}
			}
		}


		long[][][] res = new long[3][m][pow2[n - 1]];
		long[][][] temp = new long[3][n][pow2[n]];
		for (int start = 0; start < 3; start++) {
			for (int mask = 0; mask < pow2[n - 1]; mask++) {
				boolean isFine = true;
				for (int i = 0; i < n; i++) {
					int curVal = val[start][i][mask & (pow2[i] - 1)];
					isFine &= (field[i][0] == -1 || field[i][0] == curVal);
				}
				if (isFine) {
					res[start][0][mask]++;
				}
			}
		}
		for (int i = 1; i < m; i++) {
			for (int start = 0; start < 3; start++) {
				for (int mask = 0; mask < pow2[n]; mask++) {
					if (field[0][i] == -1 || field[0][i] == start) {
						temp[start][0][mask] = res[nValues[mask & 1][start]][i - 1][mask >> 1];
					} else {
						temp[start][0][mask] = 0;
					}
				}
			}
			for (int pos = 1; pos < n; pos++) {
				for (int start = 0; start < 3; start++) {
					for (int mask = 0; mask < pow2[n]; mask++) {
						int cur = val[start][pos][mask & (pow2[pos] - 1)];
						if (field[pos][i] == -1 || field[pos][i] == cur) {
							temp[start][pos][mask] = temp[start][pos - 1][mask];
							int prev = val[start][pos - 1][mask
									& (pow2[pos - 1] - 1)];
							int next = val[start][pos + 1][mask
									& (pow2[pos + 1] - 1)];
							if (prev == next) {
								int newMask = ((mask ^ pow2[pos - 1]) & (pow2[n] - 1 - pow2[pos]))
										+ (getMask[cur][prev] << pos);
								temp[start][pos][mask] += temp[start][pos - 1][newMask];
								temp[start][pos][mask] %= mod;
							}
						} else {
							temp[start][pos][mask] = 0;
						}
					}
				}
			}
			for (int start = 0; start < 3; start++) {
				for (int mask = 0; mask < pow2[n]; mask++) {
					res[start][i][mask & (pow2[n - 1] - 1)] += temp[start][n - 1][mask];
					res[start][i][mask & (pow2[n - 1] - 1)] %= mod;
				}
			}
		}
		long result = 0;
		for (int start = 0; start < 3; start++) {
			for (int mask = 0; mask < pow2[n - 1]; mask++) {
				result += res[start][m - 1][mask];
				result %= mod;
			}
		}
		out.println(result % mod);
	}

	
	public void run() throws IOException {
		br = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		solve();
		out.close();
		br.close();
	}

	public static void main(String[] args) throws IOException {
		new chess_vd_hight_precision().run();
	}

	BufferedReader br;
	StringTokenizer str;
	PrintWriter out;

	String next() throws IOException {
		while (str == null || !str.hasMoreTokens()) {
			str = new StringTokenizer(br.readLine());
		}
		return str.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

}
