import java.io.*;
import java.util.*;

public class network_bm {
    FastScanner in;
    PrintWriter out;

    void solve() {
        int tt = in.nextInt();
        for (int t = 0; t < tt; t++) {
            int n = in.nextInt() + in.nextInt();
            int[] a = new int[n];
            for (int i = 0; i < n; i++)
                a[i] = in.nextInt();
            out.println(new DpSolve(a).getAnswer());
        }
    }

    int ff(int[] a, int use) {
        int[] b = Arrays.copyOf(a, a.length);
        for (int i = 0; i < b.length; i++)
            if (b[i] == 0)
                b[i] = -1;
        int minusUse = 0, cc = 0, plusUse = 0;
        for (int i = 0; i < b.length; i++) {
            if (b[i] < 0 && minusUse < use) {
                cc += i;
                b[i] = 0;
                minusUse++;
            }
        }
        for (int i = b.length - 1; i >= 0; i--) {
            if (b[i] > 0 && plusUse < use) {
                int nowUse = Math.min(b[i], use - plusUse);
                cc += nowUse * (b.length - i);
                b[i] -= nowUse;
                plusUse += nowUse;
            }
        }
        int n = 0;
        for (int i = 0; i < a.length; i++)
            if (b[i] == -1)
                n++;
        int[][] dp = new int[2][n * 2 + 1];
        int[] qPos = new int[n * 2 + 1];
        int[] qVal = new int[n * 2 + 1];
        Arrays.fill(dp[0], Integer.MAX_VALUE / 2);
        dp[0][n] = 0;
        for (int ii = 0; ii < b.length; ii++) {
            int val = b[ii];
            Arrays.fill(dp[1], Integer.MAX_VALUE / 2);
            if (val == -1) {
                for (int i = 1; i < n * 2 + 1; i++)
                    if (dp[0][i] != Integer.MAX_VALUE / 2) {
                        int ncost = dp[0][i];
                        int rValue = i - n;
                        if (rValue <= 0) {
                            ncost -= ii;
                        } else {
                            ncost += ii;
                        }
                        dp[1][i - 1] = ncost;
                    }
            } else {
                int qIt = 0, qSz = 0, qAdd = 0;
                for (int i = 0; i < n * 2 + 1; i++) {
                    while (qIt < qSz && qPos[qIt] + val < i)
                        qIt++;
                    int realVal = i - n;
                    if (realVal <= 0) {
                        qAdd += ii;
                    } else {
                        qAdd -= ii;
                    }
                    if (dp[0][i] != Integer.MAX_VALUE / 2) {
                        int nVal = dp[0][i] - qAdd;
                        while (qIt < qSz && qVal[qSz - 1] > nVal)
                            qSz--;
                        qPos[qSz] = i;
                        qVal[qSz] = nVal;
                        qSz++;
                    }
                    if (qIt < qSz) {
                        dp[1][i] = qAdd + qVal[qIt];
                    }
                }
            }
            int[] tmp = dp[0];
            dp[0] = dp[1];
            dp[1] = tmp;
        }
        return dp[0][n] + cc;
    }

    private class DpSolve {
        int[] a;

        DpSolve(int[] a) {
            this.a = Arrays.copyOf(a, a.length);
        }

        int getAnswer(boolean rev) {
            if (rev) {
                for (int i = 0; i < a.length / 2; i++) {
                    int tmp = a[i];
                    a[i] = a[a.length - i - 1];
                    a[a.length - i - 1] = tmp;
                }
            }
            int nn = 0;
            for (int i = 0; i < a.length; i++) {
                if (a[i] == 0)
                    nn++;
            }
            int res = Integer.MAX_VALUE;
            int ll = 0, rr = nn;
            while (rr - ll > 3) {
                int m1 = ll + (rr - ll) / 3;
                int m2 = rr - (rr - ll) / 3;
                int v1 = ff(a, m1);
                int v2 = ff(a, m2);
                if (v1 < v2) {
                    rr = m2;
                } else {
                    ll = m1;
                }
            }
            for (int use = ll; use <= rr; use++) {
                res = Math.min(res, ff(a, use));
            }
            return res;
        }

        int getAnswer() {
            return Math.min(getAnswer(false), getAnswer(true));
        }
    }

    void run() {
        try {
            in = new FastScanner(new File("object.in"));
            out = new PrintWriter(new File("object.out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    void runIO() {

        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        public FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return null;
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        boolean hasMoreTokens() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return false;
                st = new StringTokenizer(s);
            }
            return true;
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }

    public static void main(String[] args) {
        new network_bm().runIO();
    }
}