import java.io.*;
import java.util.*;

public class network_bm_dp_log {
    FastScanner in;
    PrintWriter out;

    void solve() {
        int tt = in.nextInt();
        for (int t = 0; t < tt; t++) {
            int n = in.nextInt() + in.nextInt();
            int[] a = new int[n];
            for (int i = 0; i < n; i++)
                a[i] = in.nextInt();
            out.println(new DpSolve(a).getAnswer());
        }
    }

    private class DpSolve {
        int[] a;

        class Position {
            int pos, cost;

            Position(int pos, int cost) {
                this.pos = pos;
                this.cost = cost;
            }
        }

        DpSolve(int[] a) {
            this.a = a;                  
        }

        int getAnswer(boolean rev) {
            if (rev) {
                for (int i = 0; i < a.length / 2; i++) {
                    int tmp = a[i];
                    a[i] = a[a.length - i - 1];
                    a[a.length - i - 1] = tmp;
                }
            }
            int nn = 0;
            for (int i = 0; i < a.length; i++) {
                if (a[i] == 0)
                    nn++;
            }                      
            int res = Integer.MAX_VALUE;
            for (int use = 0; use <= nn; use++) {
                int[] b = Arrays.copyOf(a, a.length);
                for (int i = 0; i < b.length; i++)
                    if (b[i] == 0)
                        b[i] = -1;
                int minusUse = 0, cc = 0, plusUse = 0;
                for (int i = 0; i < b.length; i++) {
                    if (b[i] < 0 && minusUse < use) {
                        cc += i;
                        b[i] = 0;
                        minusUse++;
                    }
                }
                for (int i = b.length - 1; i >= 0; i--) {
                    if (b[i] > 0 && plusUse < use) {
                        int nowUse = Math.min(b[i], use - plusUse);
                        cc += nowUse * (b.length - i);
                        b[i] -= nowUse;
                        plusUse += nowUse;
                    }
                }
                ArrayList<Position> positions = new ArrayList<>();
                for (int i = 0; i < a.length; i++) {
                    if (b[i] == -1) {
                        positions.add(new Position(i, -1));
                    } else {
                        int val = b[i];
                        int x = 1;
                        while (x <= val) {
                            positions.add(new Position(i, x));
                            val -= x;
                            x *= 2;
                        }
                        if (val != 0)
                            positions.add(new Position(i, val));
                    }
                }
                int n = 0;
                for (int i = 0; i < a.length; i++)
                    if (b[i] == -1)
                        n++;
                int[][] dp = new int[2][n * 2 + 1];
                Arrays.fill(dp[0], Integer.MAX_VALUE / 2);
                dp[0][n] = 0;
                for (Position p : positions) {
                    Arrays.fill(dp[1], Integer.MAX_VALUE / 2);
                    for (int i = 0; i < n * 2 + 1; i++)
                        if (dp[0][i] != Integer.MAX_VALUE / 2) {
                            if (p.cost != -1)
                                dp[1][i] = Math.min(dp[1][i], dp[0][i]);
                            int nval = i + p.cost;
                            if (nval >= 0 && nval < dp[0].length) {
                                int realVal = i - n;
                                int ncost = dp[0][i];
                                if (p.cost == -1) {
                                    if (realVal > 0) {
                                        ncost += p.pos;
                                    } else {
                                        ncost -= p.pos;
                                    }
                                } else {
                                    int cost = p.cost;
                                    if (realVal < 0) {
                                        int add = Math.min(-realVal, p.cost);
                                        ncost += add * p.pos;
                                        realVal += add;
                                        cost -= add;
                                    }
                                    ncost -= cost * p.pos;
                                }
                                dp[1][nval] = Math.min(dp[1][nval], ncost);
                            }
                        }
                    int[] tmp = dp[0];
                    dp[0] = dp[1];
                    dp[1] = tmp;
                }
                res = Math.min(res, dp[0][n] + cc);
            }
            return res;
        }

        int getAnswer() {
            return Math.min(getAnswer(false), getAnswer(true));
        }
    }

    void run() {
        try {
            in = new FastScanner(new File("object.in"));
            out = new PrintWriter(new File("object.out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    void runIO() {

        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        public FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return null;
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        boolean hasMoreTokens() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return false;
                st = new StringTokenizer(s);
            }
            return true;
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }

    public static void main(String[] args) {
        new network_bm_dp_log().runIO();
    }
}