import java.io.*;
import java.util.*;

public class network_bm_mincost {
    FastScanner in;
    PrintWriter out;

    void solve() {
        int tt = in.nextInt();
        for (int t = 0; t < tt; t++) {
            int n = in.nextInt() + in.nextInt();
            int[] a = new int[n];
            for (int i = 0; i < n; i++)
                a[i] = in.nextInt();
            out.println(new MinCostSolve(a).getAnswer());
        }
    }

    class MinCostSolve {
        int[] a;

        public MinCostSolve(int[] a) {
            this.a = a;
        }

        int getAnswer() {
            int n = 0, m = 0;
            for (int i = 0; i < a.length; i++) {
                if (a[i] == 0) {
                    n++;
                } else {
                    m++;
                }
            }
            MinCostMaxFlowGraph graph = new MinCostMaxFlowGraph(2 + n + m);
            for (int i = 0; i < n; i++) {
                graph.addEdge(0, i + 1, 1, 0);
            }
            int it = 0;
            for (int i = 0; i < m; i++) {
                while (a[it] == 0)
                    it++;
                graph.addEdge(n + i + 1, n + m + 1, a[it++], 0);
            }
            int[] id = new int[a.length];
            int it1 = 0, it2 = 0;
            for (int i = 0; i < a.length; i++)
                if (a[i] == 0) {
                    id[i] = it1++;
                } else {
                    id[i] = it2++;
                }
            for (int i = 0; i < a.length; i++)
                if (a[i] == 0)
                    for (int j = 0; j < a.length; j++)
                        if (a[j] != 0) {
                            int d = Math.abs(j - i);
                            graph.addEdge(id[i] + 1, n + id[j] + 1, 1,
                                    Math.min(d, a.length - d));
                        }
            return (int) graph.getMinCostMaxFlow(0, n + m + 1)[1];
        }

        private class MinCostMaxFlowGraph {
            int n;
            ArrayList<Edge>[] g;

            class Edge {
                int from, to;
                long cap, flow, cost;
                Edge rev;

                public Edge(int from, int to, long cap, long flow, long cost) {
                    super();
                    this.from = from;
                    this.to = to;
                    this.cap = cap;
                    this.flow = flow;
                    this.cost = cost;
                }

                @Override
                public String toString() {
                    return "Edge [from=" + from + ", to=" + to + ", cap=" + cap
                            + ", flow=" + flow + ", cost=" + cost + "]";
                }
                
                
            }

            class Vertex implements Comparable<Vertex> {
                int v;
                Edge e;
                long d;

                public Vertex(int v) {
                    super();
                    this.v = v;
                }

                @Override
                public int compareTo(Vertex o) {
                    return d < o.d ? -1 : d > o.d ? 1 : v - o.v;
                }

                @Override
                public String toString() {
                    return "Vertex [v=" + v + ", e=" + e + ", d=" + d + "]";
                }

                
                
            }

            public MinCostMaxFlowGraph(int n) {
                super();
                this.n = n;
                g = new ArrayList[n];
                for (int i = 0; i < n; i++)
                    g[i] = new ArrayList<Edge>();
            }

            public void addEdge(int fr, int to, int cap, long cost) {
                Edge e1 = new Edge(fr, to, cap, 0, cost);
                Edge e2 = new Edge(to, fr, 0, 0, -cost);
                e1.rev = e2;
                e2.rev = e1;
                g[fr].add(e1);
                g[to].add(e2);
            }

            public long[] getMinCostMaxFlow(int source, int target) {
                long[] h = new long[n];
                for (boolean changed = true; changed;) {
                    changed = false;
                    for (int i = 0; i < n; i++) {
                        for (Edge e : g[i]) {
                            if (e.cap > 0 && h[e.to] > h[e.from] + e.cost) {
                                h[e.to] = h[e.from] + e.cost;
                                changed = true;
                            }
                        }
                    }
                }
                Vertex[] vertices = new Vertex[n];
                long[] d = new long[n];
                for (int i = 0; i < vertices.length; i++) {
                    vertices[i] = new Vertex(i);
                }
                int flow = 0;
                long cost = 0;
                while (true) {
                    dijkstra(source, vertices, d, h);
                    if (d[target] == Long.MAX_VALUE) {
                        break;
                    }
                    long addFlow = Long.MAX_VALUE;
                    Vertex v = vertices[target];
                    while (v != vertices[source]) {
                        addFlow = Math.min(addFlow, v.e.cap - v.e.flow);
                        v = vertices[v.e.from];
                    }
                    cost += (d[target] + h[target] - h[source]) * addFlow;
                    flow += addFlow;
                    v = vertices[target];
                    while (v != vertices[source]) {
                        v.e.flow += addFlow;
                        v.e.rev.flow -= addFlow;
                        v = vertices[v.e.from];
                    }
                    for (int i = 0; i < n; i++) {
                        h[i] += d[i] == Long.MAX_VALUE ? 0 : d[i];
                    }
                }
                return new long[] { flow, cost };
            }

            void dijkstra(int source, Vertex[] vertices, long[] d, long[] h) {
                Arrays.fill(d, Long.MAX_VALUE);
                for (int i = 0; i < vertices.length; i++) {
                    vertices[i].d = Long.MAX_VALUE;
                }
                d[source] = 0;
                vertices[source].d = 0;
                int n = vertices.length;
                boolean[] was = new boolean[n];
                while (true) {
                    int best = -1;
                    for (int i = 0; i < n; i++)
                        if (!was[i] && d[i] != Long.MAX_VALUE && (best == -1 || d[i] < d[best])) {
                            best = i;
                        }
                    if (best == -1)
                        break;
                    was[best] = true;
                    for (Edge e : g[best]) {
                        if (e.flow >= e.cap)
                            continue;
                        if (d[e.to] > d[e.from] + e.cost + h[e.from] - h[e.to]) {
                            d[e.to] = d[e.from] + e.cost + h[e.from] - h[e.to];
                            vertices[e.to].d = d[e.to];
                            vertices[e.to].e = e;
                        }
                    }
                }
            }
        }
    }

    void run() {
        try {
            in = new FastScanner(new File("object.in"));
            out = new PrintWriter(new File("object.out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    void runIO() {

        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        public FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return null;
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        boolean hasMoreTokens() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return false;
                st = new StringTokenizer(s);
            }
            return true;
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }

    public static void main(String[] args) {
        new network_bm_mincost().runIO();
    }
}