import java.io.*;
import java.util.*;

public class network_bm_wa {
    FastScanner in;
    PrintWriter out;

    class Edge implements Comparable<Edge> {
    	int fr, to, cost;

    	Edge(int fr, int to, int cost) {
    	 	this.fr = fr;
    	 	this.to = to;
    	 	this.cost = cost;
    	}

    	public int compareTo(Edge o) {
    		return Integer.compare(cost, o.cost);
    	}
    }

    void solve() {
        int tt = in.nextInt();
        for (int t = 0; t < tt; t++) {
            int n = in.nextInt() + in.nextInt();
            int[] a = new int[n];
            for (int i = 0; i < n; i++)
                a[i] = in.nextInt();
           	List<Edge> l = new ArrayList<Edge>();
           	for (int i = 0; i < n; i++)
           		if (a[i] == 0)
           			for (int j = 0; j < n; j++)
           				if (a[j] != 0) {
           					int d = Math.abs(j - i);
           					l.add(new Edge(i, j, Math.min(d, n - d)));
           				}
           	Collections.sort(l);
           	boolean[] used = new boolean[n];
           	int cost = 0;
           	for (Edge e : l) {
				if (!used[e.fr] && a[e.to] > 0) {
					used[e.fr] = true;
					a[e.to]--;
					cost += e.cost;
				}
           	}
			out.println(cost);
        }
    }

    void run() {
        try {
            in = new FastScanner(new File("object.in"));
            out = new PrintWriter(new File("object.out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    void runIO() {

        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        public FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return null;
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        boolean hasMoreTokens() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return false;
                st = new StringTokenizer(s);
            }
            return true;
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }

    public static void main(String[] args) {
        new network_bm_wa().runIO();
    }
}