import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayDeque;
import java.util.Arrays;
import java.util.StringTokenizer;

public class network_va implements Runnable {
    public static void main(String[] args) {
        new Thread(new network_va()).run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }

        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public class State {
        int p, v, add;

        public State(int p, int v) {
            this.p = p;
            this.v = v;
        }

        public String toString() {
            return p + " " + v + " " + add;
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();

        int len = n + m;

        int[] ab = new int[m];
        int[] cb = new int[m];
        int[] b = new int[n];

        int la = 0;
        int lb = 0;
        for (int i = 0; i < n + m; i++) {
            int x = nextInt();
            if (x == 0) {
                b[lb++] = i;
            } else {
                ab[la] = i;
                cb[la++] = x;
            }
        }

        int INF = Integer.MAX_VALUE / 2;

        int best = INF;

        for (int rev = 0; rev < 2; rev++) {
            for (int left = 0; left <= b.length; left++) {
                int[] c = Arrays.copyOf(cb, cb.length);
                int add = 0;
                int r = 0;
                for (int p = b.length - left; p < b.length; p++) {
                    if (c[r] == 0) {
                        r++;
                    }
                    add += ab.length + b.length + ab[r] - b[p];
                    c[r]--;
                }

                if (c[r] == 0)
                    r++;


                int[] a = Arrays.copyOfRange(ab, r, c.length);
                c = Arrays.copyOfRange(c, r, c.length);

                n = b.length - left;
                m = c.length;

                if (m == 0 || n == 0) {
                    best = Math.min(best, add);
                    continue;
                }

                int[][] ans = new int[m][n + 1];

                for (int i = 0; i < ans.length; i++) {
                    Arrays.fill(ans[i], INF);
                }

                ans[0][0] = 0;
                for (int i = 1; i <= Math.min(c[0], n); i++) {
                    ans[0][i] = ans[0][i - 1] + Math.abs(a[0] - b[i - 1]);
                }

//                System.err.println("!!!");
//                System.err.println(Arrays.toString(a));
//                System.err.println(Arrays.toString(b));
                best = Math.min(best, ans[0][n] + add);
//                System.err.println(0 + " " + Arrays.toString(ans[0]) + " " + add);

                for (int i = 1; i < m; i++) {
                    ArrayDeque<State> state = new ArrayDeque<State>();
                    ans[i][0] = ans[i - 1][0];
                    state.add(new State(0, 0));
                    int total = 0;
                    for (int j = 1; j <= n; j++) {
                        if (!state.isEmpty() && state.getFirst().p < j - c[i]) {
                            total -= state.pollFirst().add;
                        }

                        int sum = Math.abs(a[i] - b[j - 1]);

                        total += sum;

                        if (ans[i - 1][j] != INF) {
                            State s = new State(j, ans[i - 1][j]);

                            while (!state.isEmpty()) {
                                State t = state.getLast();
                                if (t.v + t.add + sum > s.v) {
                                    state.pollLast();
                                    sum += t.add;
                                } else {
                                    t.add += sum;
                                    break;
                                }
                            }

                            if (state.isEmpty())
                                total = 0;

                            state.addLast(s);
                        }

//                        System.err.println(j + " " + state + " " + total + " " + add);

                        if (!state.isEmpty())
                            ans[i][j] = state.getFirst().v + total;
                    }
                    best = Math.min(best, ans[i][n] + add);
//                    System.err.println(i + " " + Arrays.toString(ans[i]));
                }
            }

            for (int i = 0; i < b.length / 2; i++) {
                int p = b[i];
                b[i] = b[b.length - i - 1];
                b[b.length - i - 1] = p;
            }

            for (int i = 0; i < b.length; i++) {
                b[i] = len - 1 - b[i];
            }

            for (int i = 0; i < ab.length / 2; i++) {
                int p = ab[i];
                ab[i] = ab[ab.length - i - 1];
                ab[ab.length - i - 1] = p;
                p = cb[i];
                cb[i] = cb[cb.length - i - 1];
                cb[cb.length - i - 1] = p;
            }

            for (int i = 0; i < ab.length; i++) {
                ab[i] = len - 1 - ab[i];
            }

//            System.err.println(Arrays.toString(ab));
//            System.err.println(Arrays.toString(cb));
//            System.err.println(Arrays.toString(b));
        }

        out.println(best);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            int t = nextInt();
            for (int i = 0; i < t; i++)
                solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
